"""
    FactSet Fundamentals API

    Gain access to current, comprehensive, and comparative information on securities in worldwide developed and emerging markets. Composed of annual and interim/quarterly data, detailed historical financial statement content, per share data, and calculated ratios, FactSet Fundamentals provides you with the information you need for a global investment perspective.   # noqa: E501

    The version of the OpenAPI document: 1.0.2
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FactSetFundamentals.api_client import ApiClient, Endpoint as _Endpoint
from fds.sdk.FactSetFundamentals.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from fds.sdk.FactSetFundamentals.model.error_response import ErrorResponse
from fds.sdk.FactSetFundamentals.model.metrics_request import MetricsRequest
from fds.sdk.FactSetFundamentals.model.metrics_response import MetricsResponse


class DataItemsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.get_fds_fundamentals_metrics_endpoint = _Endpoint(
            settings={
                'response_type': (MetricsResponse,),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/factset-fundamentals/v1/metrics',
                'operation_id': 'get_fds_fundamentals_metrics',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'category',
                    'subcategory',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                    'category',
                    'subcategory',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('category',): {

                        "INCOME_STATEMENT": "INCOME_STATEMENT",
                        "BALANCE_SHEET": "BALANCE_SHEET",
                        "CASH_FLOW": "CASH_FLOW",
                        "RATIOS": "RATIOS",
                        "FINANCIAL_SERVICES": "FINANCIAL_SERVICES",
                        "INDUSTRY_METRICS": "INDUSTRY_METRICS",
                        "PENSION_AND_POSTRETIREMENT": "PENSION_AND_POSTRETIREMENT",
                        "MARKET_DATA": "MARKET_DATA",
                        "MISCELLANEOUS": "MISCELLANEOUS",
                        "DATES": "DATES"
                    },
                    ('subcategory',): {

                        "AIRLINES": "AIRLINES",
                        "ASSETS": "ASSETS",
                        "BALANCE_SHEET": "BALANCE_SHEET",
                        "BANKING": "BANKING",
                        "CASH_FLOW": "CASH_FLOW",
                        "CHANGE_IN_CASH": "CHANGE_IN_CASH",
                        "CLASSIFICATION": "CLASSIFICATION",
                        "CORPORATE_DATA": "CORPORATE_DATA",
                        "DATES": "DATES",
                        "EMPLOYEES_AND_MANAGEMENT": "EMPLOYEES_AND_MANAGEMENT",
                        "FINANCIAL": "FINANCIAL",
                        "FINANCIAL_RECORDS": "FINANCIAL_RECORDS",
                        "FINANCING": "FINANCING",
                        "GROWTH_RATE": "GROWTH_RATE",
                        "HEALTHCARE": "HEALTHCARE",
                        "HOTELS_AND_GAMING": "HOTELS_AND_GAMING",
                        "INCOME_STATEMENT": "INCOME_STATEMENT",
                        "INDICATOR": "INDICATOR",
                        "INVESTING": "INVESTING",
                        "LIABILITIES": "LIABILITIES",
                        "LIQUIDITY": "LIQUIDITY",
                        "MARKET_DATA": "MARKET_DATA",
                        "METALS_AND_MINING": "METALS_AND_MINING",
                        "NON-OPERATING": "NON-OPERATING",
                        "OIL_AND_GAS": "OIL_AND_GAS",
                        "OPERATING": "OPERATING",
                        "PENSION_AND_POSTRETIREMENT": "PENSION_AND_POSTRETIREMENT",
                        "PER_SHARE": "PER_SHARE",
                        "PHARMACEUTICAL": "PHARMACEUTICAL",
                        "PROFITABILITY": "PROFITABILITY",
                        "REIT": "REIT",
                        "RETAIL": "RETAIL",
                        "SHAREHOLDERS_EQUITY": "SHAREHOLDERS_EQUITY",
                        "SIZE": "SIZE",
                        "SUPPLEMENTAL": "SUPPLEMENTAL",
                        "VALUATION": "VALUATION",
                        "BANK": "BANK",
                        "INSURANCE": "INSURANCE",
                        "UTILITY": "UTILITY"
                    },
                },
                'openapi_types': {
                    'category':
                        (str,),
                    'subcategory':
                        (str,),
                },
                'attribute_map': {
                    'category': 'category',
                    'subcategory': 'subcategory',
                },
                'location_map': {
                    'category': 'query',
                    'subcategory': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_fds_fundamentals_metrics_for_list_endpoint = _Endpoint(
            settings={
                'response_type': (MetricsResponse,),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/factset-fundamentals/v1/metrics',
                'operation_id': 'get_fds_fundamentals_metrics_for_list',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'metrics_request',
                ],
                'required': [
                    'metrics_request',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'metrics_request':
                        (MetricsRequest,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'metrics_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def get_fds_fundamentals_metrics(
        self,
        **kwargs
    ):
        """Available fundamental metrics or ratios.  # noqa: E501

        Returns list of available FF_* metrics that can be used in the `metrics` parameter of related endpoints. These are related to FactSet Fundamentals standardized data. As Reported will be available in future endpoints. Leave Category and Subcategory blank to request all available items. The Endpoint Data model is optimized for timeseries data with periodicity. Some items in this list are non-timeseries. **For methodology definitions, reference the `OApageID` or `OAurl` response items to launch the available methodology page.**   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_fds_fundamentals_metrics(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            category (str): Filters the list of FF_* metrics by major category -   * **INCOME_STATEMENT** = Income Statement line items, such as Sales, Gross Profit, Net Income.   * **BALANCE_SHEET** = Balance Sheet line items, such as Assets, Liabilities, and Shareholders Equity.   * **CASH_FLOW** = Cash Flow Statement line items, such as Financing activities, Operation, and Per Share.   * **RATIOS** = Pre-calculated Ratios, including Financial, Growth Rates, Profitability, Liquidity, Size, and Valuation.   * **FINANCIAL_SERVICES** = Financial Statement Items modified for Financial Services companies.   * **INDUSTRY_METRICS** = Industry Specific Line Items or Modifications. View subcategory for list of Industries.   * **PENSION_AND_POSTRETIREMENT** = Accumulated Pension Benefit Obligations and related data.   * **MARKET_DATA** = General Market Data, such as Shares Outstanding. *Note - /factset-prices/prices/ endpoints may be better suited for pricing related market data.*   * **MISCELLANEOUS** = Corporation Data, Financial Records details, Indicators.   * **DATES** = Relevant Dates . [optional]
            subcategory (str): Sub-Category Filter for the Primary Category Requested. Choose a related sub-category for the Category requested-   * **INCOME_STATEMENT** - INCOME_STATEMENT, NON-OPERATING, PER_SHARE, SUPPLEMENTAL   * **BALANCE_SHEET** - ASSETS, BALANCE_SHEET, HEALTHCARE, LIABILITIES, PER_SHARE, SHAREHOLDERS_EQUITY, SUPPLEMENTAL   * **CASH_FLOW** - CASH_FLOW, CHANGE_IN_CASH, FINANCING, INVESTING, OPERATING, PER_SHARE, SUPPLEMENTAL   * **RATIOS** - FINANCIAL, GROWTH_RATE, LIQUIDITY, PROFITABILITY, SIZE, VALUATION   * **FINANCIAL_SERVICES** - BALANCE_SHEET, INCOME_STATEMENT, SUPPLEMENTAL   * **INDUSTRY_METRICS** - AIRLINES, BANKING, HOTELS_AND_GAMING, METALS_AND_MINING, OIL_AND_GAS, PHARMACEUTICAL, REIT, RETAIL, BANK, INSURANCE, UTILITY   * **PENSION_AND_POSTRETIREMENT** - PENSION_AND_POSTRETIREMENT   * **MARKET_DATA** - MARKET_DATA   * **MISCELLANEOUS** - CLASSIFICATION, CORPORATE_DATA, FINANCIAL_RECORDS, INDICATOR, EMPLOYEES_AND_MANAGEMENT   * **DATES** - DATES . [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            MetricsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.get_fds_fundamentals_metrics_endpoint.call_with_http_info(**kwargs)

    def get_fds_fundamentals_metrics_for_list(
        self,
        metrics_request,
        **kwargs
    ):
        """Available fundamental metrics or ratios.  # noqa: E501

        Returns list of available FF_* metrics that can be used in the `metrics` parameter of related endpoints. These are related to FactSet Fundamentals standardized data. As-Reported will be available in future endpoints. Leave Category and Subcategory blank to request all available items. The Endpoint Data model is optimized for timeseries data with periodicity. Some items in this list are non-timeseries.        **For methodology definitions, reference the `OApageID` or `OAurl` response items to launch the available methodology page.**   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_fds_fundamentals_metrics_for_list(metrics_request, async_req=True)
        >>> result = thread.get()

        Args:
            metrics_request (MetricsRequest): Request object for requesting fundamentals data

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            MetricsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['metrics_request'] = \
            metrics_request
        return self.get_fds_fundamentals_metrics_for_list_endpoint.call_with_http_info(**kwargs)

